Ticket #30706

URLとメールアドレスを情報処理点字で点訳する

Open Date: 2013-02-09 00:46 Last Update: 2013-03-02 13:43

Reporter:
Owner:
Status:
Closed
Component:
(None)
MileStone:
Priority:
5 - Medium
Severity:
5 - Medium
Resolution:
None
File:
None

Details

チケット #30164 と重複するのですが、スコープを狭めたタスクになっているので、独立したチケットにします。

日本語点訳エンジンにおいてURL(具体的には http:// で始まるもの)とメールアドレスを情報処理点字で点訳する、という仕様が提案されたので、実装を検討しています。

URLは RFC3986 が正式な仕様のようです。

http://tools.ietf.org/html/rfc3986

RFC3986 準拠の実装についてのブログ記事

http://d.hatena.ne.jp/a_bicky/20120804/1344071654

全角で記述されているものは Unicode 正規化してから処理する方針ですが、「~」記号は半角オーバーラインと見なすなど、いくつか例外処理が必要になりそうです。

http://新宿駅.jp のようないわゆる日本語ドメイン名には情報処理点字を適用しません。

メールアドレスについては先頭に mailto: がなくても URL と同等に、情報処理点字で処理します。

一方で、www.nvda.jp のような文字列は厳密にはURLではないので、外国語引用符で囲む(ピリオドの後にマスアケはしない)ことにします。 また、メールアドレスも @ の前後に空白があるなど、メールアドレスの形式に厳密に従っていない文字列は外国語引用符とします。

いまテストケースを作成しているところですが、このような方針でよろしいでしょうか。

ご意見やご要望があればご指摘ください。

Ticket History (3/8 Histories)

2013-02-09 00:46 Updated by: nishimoto
  • New Ticket "URLとメールアドレスを情報処理点字で点訳する" created
2013-02-09 19:31 Updated by: nishimoto
  • Owner Update from (None) to nishimoto
Comment

このチケットに関する作業は jpmain ではなく、チケット番号に基づく名前のブランチ ti30706 で行い、このチケットに関する作業と、jpmain からのマージだけを行います。

lp:~nishimotz/nvdajp/ti30706

2013-02-11 22:57 Updated by: nishimoto
Comment

本件の要求とは完全には一致しませんが、もう少し実装しやすい仕様として、下記を検討させてください。

  • 情報処理点字でしか表現できない記号が出てきたときには、できるだけ前後のアルファベット、数字、空白をつなぎ合わせて、全体を外国語引用符の開始記号、終了記号ではさみ、その中を情報処理点字の体系で点訳する。
  • この仕様案では :// や @ が含まれる文字列は全体が情報処理点字になる。
  • C:\Program Files は全体が情報処理点字になる。
  • C:\Users\ユーザー は先頭から「ユ」の手前までが情報処理点字になる。
  • カッコやピリオドなど、日本点字で対応できる記号が単独で出現したときには情報処理点字にしない。が、詳細は要検討。
2013-02-13 15:03 Updated by: nishimoto
Comment

アットマーク、バックスラッシュおよび "://" が出現したときに情報処理点字を使う処理の実装に取りかかっています。

開発スナップショット jpbrl130213 https://dl.dropbox.com/u/62564469/nvda_snapshot_jpbrl130213.exe

空白を含まない1単語のアルファベット文字列は外国語引用符を使わない、という処理も実装しました。

二重大文字符に関する仕様変更はまだ行っていません。

いくつかの記号は情報処理点字として正しく変換できることを優先したので、日本語点字モードでの処理が不完全です。 これからテストケースを追加して、使い分けをしていく予定です。

また、ドキュメントはまだ改訂していません。

ソースは lp:~nishimotz/nvdajp/ti30706 にあります。

この作業が完了するまで jpmain ブランチにマージしないで、jpbrl として開発スナップショットを作ります。

2013-02-15 17:06 Updated by: nishimoto
Comment

点訳テストケースに見出しや目次を入れて読みやすくしました。

https://dl.dropbox.com/u/62564469/jpBrailleHarness.html

日本語、カナ表記、点字が揃っていればNVDA日本語版の点訳エンジンで正しく処理できることを意味します。 開発しながら随時更新します。

次の開発スナップショットでは、二重大文字符の処理が改良され、すべて大文字のアルファベット文字列に限って二重大文字符を使うようになります。

2013-02-15 20:24 Updated by: nishimoto
Comment

情報処理点字と日本語点字(点訳のてびき 第4章 記号類の使い方)の両方を考慮した記号の処理を実装しました。

開発スナップショット jpbrl130215b https://dl.dropbox.com/u/62564469/nvda_snapshot_jpbrl130215b.exe

このブランチでの作業はこれで終わりにする予定です。

2013-02-16 00:03 Updated by: nishimoto
  • Milestone Update from (None) to 2013.1jp (closed)
  • Ticket Close date is changed to 2013-02-16 00:03
  • Status Update from Open to Closed
Comment

jpmain 4532 にマージしました。

2013-03-02 13:43 Updated by: nishimoto
Comment

情報処理点字で「数字、ピリオド、アルファベットのaからjまでの文字」が並ぶときにピリオドの直後に小文字符 56 を挿入する処理を jpmain 4541 でコミットしました。

Attachment File List

No attachments

Edit

Please login to add comment to this ticket » Login